#!/usr/bin/python                                                                       
#   Project: Master Thesis                                                              
#   Author: Bjornar Brende Smestad                                                      
#   Created: Spring 2015                                                                


import aisparser           
import sqlite3 as lite
import sys
import os


def extractMessages(filepath):
    global messageType1
    global messageType2
    global messageType3         
    global messageType4
    global messageType5
    global timeStamps1 
    global timeStamps2
    global timeStamps3 
    global timeStamps4 
    global timeStamps5 
    messageType1 = []
    messageType2 = []
    messageType3 = []
    messageType4 = []
    messageType5 = []
    timeStamps1 = []
    timeStamps2 = []
    timeStamps3 = []
    timeStamps4 = []
    timeStamps5 = []
    s = []
    i = 0
    f = open(filepath, 'r')
    for line in f:
        s.append('c:'+line.split('c:')[1].split('*')[0]+'!BSVDM'+line.split('!BSVDM')[1])
    ais_state = aisparser.ais_state()
    for p in s:

        result = aisparser.assemble_vdm( ais_state, p )
        if( result == 0):
            timestamp = p.split('c:')[1].split('*')[0].split('!')[0]
            ais_state.msgid = aisparser.get_6bit( ais_state.six_state, 6 )
            i = i+1
            if ais_state.msgid == 1:
                msg = aisparser.aismsg_1()
                aisparser.parse_ais_1( ais_state, msg )
                timeStamps1.append(timestamp)
                messageType1.append(msg)
                print msg
            elif ais_state.msgid == 2:
                msg = aisparser.aismsg_2()
                aisparser.parse_ais_2( ais_state, msg )
                timeStamps2.append(timestamp)
                messageType2.append(msg)
                print msg
            elif ais_state.msgid == 3:
                msg = aisparser.aismsg_3()
                aisparser.parse_ais_3( ais_state, msg )
                timeStamps3.append(timestamp)
                messageType3.append(msg)
                print msg
            elif ais_state.msgid == 4:
                msg = aisparser.aismsg_4()
                aisparser.parse_ais_4( ais_state, msg )
                (status,lat_dd,long_ddd) = aisparser.pos2ddd(msg.latitude, msg.longitude)
                timeStamps4.append(timestamp)
                messageType4.append(msg)
                print msg
            elif ais_state.msgid == 5:
                msg = aisparser.aismsg_5()
                aisparser.parse_ais_5( ais_state, msg )
                timeStamps5.append(timestamp)
                messageType5.append(msg)
                print msg
            if i > 1:
                break

def createDatabase(databasepath):

    con = lite.connect(databasepath)

    with con:
    
        cur = con.cursor()
        cur.execute("CREATE TABLE MessageType1(unixtime int, cog INT, latitude INT, longitude INT, msgid INT, nav_status INT, pos_acc INT, raim INT, regional INT, repeat INT, rot INT, slot_timeout INT, sog INT, spare INT, sub_message INT, sync_state INT, true INT, userid INT, utc_sec INT)")
        cur.execute("CREATE TABLE MessageType2(unixtime int, cog INT, latitude INT, longitude INT, msgid INT, nav_status INT, pos_acc INT, raim INT, regional INT, repeat INT, rot INT, slot_timeout INT, sog INT, spare INT, sub_message INT, sync_state INT, true INT, userid INT, utc_sec INT)")
        cur.execute("CREATE TABLE MessageType3(unixtime int, cog int,keep INT,latitude INT,longitude INT,msgid INT,nav_status INT,num_slots INT,pos_acc INT,raim INT,regional INT,repeat INT,rot INT,slot_increment int,sog int,spare INT,sync_state INT, true int,userid INT, utc_sec INT)")
        cur.execute("CREATE TABLE MessageType4(unixtime int, latitude INT,longitude INT,msgid INT,pos_acc INT,pos_type INT,raim INT,repeat INT,slot_timeout INT,spare int,sub_message int,sync_state INT,userid INT,utc_day INT,utc_hour INT,utc_minute INT,utc_month INT,utc_second INT,utc_year int)")
        cur.execute("CREATE TABLE MessageType5(unixtime int, callsign string,dest string,dim_bow int,dim_port INT,dim_starboard INT,dim_stern int,draught INT,dte INT,eta INT,imo INT,msgid INT,name text,pos_type INT,repeat INT,ship_type INT,spare INT ,userid INT,version INT)")
        cur.execute("CREATE INDEX userid_index ON MessageType1 (userid)")
        cur.execute("CREATE INDEX userid_index2 ON MessageType2 (userid)")
        cur.execute("CREATE INDEX userid_index3 ON MessageType3 (userid)")
        cur.execute("CREATE INDEX userid_index4 ON MessageType4 (userid)")
        cur.execute("CREATE INDEX userid_index5   ON MessageType5 (userid)")
        cur.execute("CREATE INDEX unixtime_index ON MessageType1 (unixtime)")
        cur.execute("CREATE INDEX unixtime_index2 ON MessageType2 (unixtime)")
        cur.execute("CREATE INDEX unixtime_index3 ON MessageType3 (unixtime)")
        cur.execute("CREATE INDEX unixtime_index4 ON MessageType4 (unixtime)")
        cur.execute("CREATE INDEX unixtime_index5   ON MessageType5 (unixtime)")

def writeToDatabase(databasepath):
    con = lite.connect(databasepath)
    con.isolation_level = None

    with con:
        cur = con.cursor()  
        cur.execute('BEGIN TRANSACTION')  
        for i in range(0, len(messageType1)):
            (status,lat_dd,long_ddd) = aisparser.pos2ddd(messageType1[i].latitude, messageType1[i].longitude)
            cur.execute("INSERT OR IGNORE INTO MessageType1(unixtime, cog , latitude , longitude , msgid , nav_status , pos_acc , raim , regional , repeat , rot , slot_timeout , sog, spare, sub_message, sync_state, true, userid, utc_sec) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", 
                (timeStamps1[i], messageType1[i].cog, lat_dd, long_ddd, ord(messageType1[i].msgid),ord(messageType1[i].nav_status),
                    ord(messageType1[i].pos_acc), ord(messageType1[i].raim), ord(messageType1[i].regional), ord(messageType1[i].repeat), messageType1[i].rot, 
                    ord(messageType1[i].slot_timeout),messageType1[i].sog, ord(messageType1[i].spare), messageType1[i].sub_message, ord(messageType1[i].sync_state), 
                    messageType1[i].true, messageType1[i].userid, ord(messageType1[i].utc_sec)))
        for i in range(0, len(messageType2)):
            (status,lat_dd,long_ddd) = aisparser.pos2ddd(messageType2[i].latitude, messageType2[i].longitude)
            cur.execute("INSERT OR IGNORE INTO MessageType2(unixtime, cog , latitude , longitude , msgid , nav_status , pos_acc , raim , regional , repeat , rot , slot_timeout , sog, spare, sub_message, sync_state, true, userid, utc_sec) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", 
                (timeStamps2[i], messageType2[i].cog, lat_dd, long_ddd, ord(messageType2[i].msgid),ord(messageType2[i].nav_status),
                    ord(messageType2[i].pos_acc), ord(messageType2[i].raim), ord(messageType2[i].regional), ord(messageType2[i].repeat), messageType2[i].rot, 
                    ord(messageType2[i].slot_timeout),messageType2[i].sog, ord(messageType2[i].spare), messageType2[i].sub_message, ord(messageType2[i].sync_state), 
                    messageType2[i].true, messageType2[i].userid, ord(messageType2[i].utc_sec)))
        for i in range(0, len(messageType3)):
            (status,lat_dd,long_ddd) = aisparser.pos2ddd(messageType3[i].latitude, messageType3[i].longitude)
            cur.execute("INSERT OR IGNORE INTO MessageType3(unixtime, cog,keep,latitude,longitude,msgid,nav_status,num_slots,pos_acc,raim,regional,repeat,rot,slot_increment,sog,spare,sync_state, true,userid, utc_sec) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", (timeStamps3[i], messageType3[i].cog, ord(messageType3[i].keep) , 
                lat_dd, long_ddd, ord(messageType3[i].msgid) , ord(messageType3[i].nav_status) , ord(messageType3[i].num_slots) , ord(messageType3[i].pos_acc) , 
                ord(messageType3[i].raim) , ord(messageType3[i].regional) , ord(messageType3[i].repeat) , messageType3[i].rot, messageType3[i].slot_increment, messageType3[i].sog, 
                ord(messageType3[i].spare) , ord(messageType3[i].sync_state) ,messageType3[i].true, messageType3[i].userid, ord(messageType3[i].utc_sec)))
        for i in range(0, len(messageType4)):
            (status,lat_dd,long_ddd) = aisparser.pos2ddd(messageType4[i].latitude, messageType4[i].longitude)
            cur.execute("INSERT OR IGNORE INTO MessageType4(unixtime, latitude,longitude,msgid,pos_acc,pos_type,raim,repeat,slot_timeout,spare,sub_message,sync_state,userid,utc_day,utc_hour,utc_minute,utc_month,utc_second,utc_year) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", (timeStamps4[i], lat_dd, long_ddd, ord(messageType4[i].msgid) , ord(messageType4[i].pos_acc) , 
                ord(messageType4[i].pos_type) , ord(messageType4[i].raim) , ord(messageType4[i].repeat) , ord(messageType4[i].slot_timeout) , messageType4[i].spare, messageType4[i].sub_message, 
                ord(messageType4[i].sync_state) ,  messageType4[i].userid, ord(messageType4[i].utc_day) , ord(messageType4[i].utc_hour) , ord(messageType4[i].utc_minute) , ord(messageType4[i].utc_month) , 
                ord(messageType4[i].utc_second) , messageType4[i].utc_year))        
        for i in range(0, len(messageType5)):
            messageType5[i].dest = messageType5[i].dest.replace(" ","")
            messageType5[i].dest = messageType5[i].dest.replace("@","")
            messageType5[i].callsign = messageType5[i].callsign.replace(" ","")
            messageType5[i].callsign = messageType5[i].callsign.replace("@","")
            messageType5[i].name = messageType5[i].name.replace(" ","")
            messageType5[i].name = messageType5[i].name.replace("@","")
            cur.execute("INSERT OR IGNORE INTO MessageType5(unixtime, callsign, dest, dim_bow, dim_port, dim_starboard, dim_stern, draught, dte, eta, imo, msgid, name, pos_type, repeat, ship_type, spare , userid, version) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", (timeStamps5[i], messageType5[i].callsign , messageType5[i].dest, messageType5[i].dim_bow, ord(messageType5[i].dim_port) , 
                ord(messageType5[i].dim_starboard) , messageType5[i].dim_stern, messageType5[i].draught, ord(messageType5[i].dte) , messageType5[i].eta, messageType5[i].imo, ord(messageType5[i].msgid) , messageType5[i].name , 
                ord(messageType5[i].pos_type) , ord(messageType5[i].repeat) , messageType5[i].ship_type, ord(messageType5[i].spare) , messageType5[i].userid, ord(messageType5[i].version)))        
        cur.execute('COMMIT')

if __name__ == "__main__":
    databasepath = ""
    createDatabase(databasepath)
    for foldername in os.listdir('../../../../../media/bjornasm/My Passport/AIS Rawdata/Kystverket/'):
        for filename in os.listdir('../../../../../media/bjornasm/My Passport/AIS Rawdata/Kystverket/'+foldername):
            extractMessages('../../../../../media/bjornasm/My Passport/AIS Rawdata/Kystverket/'+foldername+'/'+filename)
            writeToDatabase(databasepath)


