#!/usr/bin/python                                                                       
#   Project: Master Thesis                                                              
#   Author: Bjornar Brende Smestad                                                      
#   Created: Spring 2015 

import sqlite3 as lite

def getImoNumbers(databasepath, table):
    con = lite.connect(databasepath)

    with con:
        cur = con.execute("SELECT distinct imo FROM {table}".format(table = table))
        con.commit()
        imonumbers = [int(x[0]) for x in cur]
    con.close()
    return imonumbers

def checkImoNumber(number):
	number = str(number)
	checksum = 0
	if len(number) != 7:
		return False
	if len(number) == 0:
		return True
	for i in range(0,6):
		checksum += int(number[i])*(7-i)
	if str(checksum)[-1] != number[-1]:
		return False
	return True

if __name__ == "__main__":
	numtrues = 0
	numfalse = 0
	imonumbers = getImoNumbers('database/s/SAISREAL.db', 'staticMessage')
	for num in imonumbers:
		if checkImoNumber(num):
			numtrues += 1
		else:
			numfalse += 1
			print num
	print "Total IMOs"
	print numtrues+numfalse
	print "Number of true IMOs"
	print numtrues
	print "Number of false IMOs"
	print numfalse



