#!/usr/bin/python                                                                       
#   Project: Master Thesis                                                              
#   Author: Bjornar Brende Smestad                                                      
#   Created: Spring 2015 

import sqlite3 as lite
import sys
import os
import numpy as np
import datetime
import matplotlib.pyplot as plt
from mpl_toolkits.basemap import Basemap

if __name__ == "__main__":
	map = Basemap(projection='cyl',
	resolution = 'c', area_thresh = 40,
	llcrnrlon=-180, llcrnrlat=-90,
	urcrnrlon=180, urcrnrlat=90)

	with lite.connect('database/s/SAISREAL.db') as con:
		start = 1406851200
		end = 1409529600
		middle = start + (end-start)/2
		cur = con.cursor()
		cur.execute('SELECT latitude, longitude FROM dynamicMessage WHERE unixtime >= {start} AND unixtime < {middle}'.format(start = start, middle = middle))
		data = cur.fetchall()
		y,x = zip(*data)
		x,y = map(x,y)
		plt.scatter(x,y, s=0.02, alpha=0.4, color="#e74c3c", edgecolors='none')
		cur.execute('SELECT latitude, longitude FROM dynamicMessage WHERE unixtime >= {middle} AND unixtime < {end}'.format(middle = middle, end = end))
		data = cur.fetchall()
		y,x = zip(*data)
		x,y = map(x,y)
		plt.scatter(x,y, s=0.02, alpha=0.4, color="#e74c3c", edgecolors='none')
		plt.savefig('AugustGlobalPlot.png', bbox_inches='tight')
		plt.clf()
